Botan 1.10.17

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Botan::PBE_PKCS5v20 Class Reference

`#include <pbes2.h>`

Inheritance diagram for Botan::PBE_PKCS5v20:

## Public Member Functions
virtual bool | attachable ()
void | end_msg ()
std::string | name () const
| PBE_PKCS5v20 (DataSource &input)
| PBE_PKCS5v20 (BlockCipher *cipher, HashFunction *hash)
void | start_msg ()
void | write (const byte[], size_t)
| ~PBE_PKCS5v20 ()

## Static Public Member Functions
static bool | known_cipher (const std::string &cipher)

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

PKCS #5 v2.0 PBE

Definition at line 21 of file pbes2.h.

## Constructor & Destructor Documentation

## ◆ PBE_PKCS5v20() [1/2]

Botan::PBE_PKCS5v20::PBE_PKCS5v20 | ( | DataSource & | input | ) |

Load a PKCS #5 v2.0 encrypted stream

Parameters

  input | is the input source

Definition at line 228 of file pbes2.cpp.

228 : direction(DECRYPTION)
229 {
230 hash_function = 0;
231 block_cipher = 0;
232 decode_params(params);
233 }
Botan::DECRYPTION
Definition: sym_algo.h:87

## ◆ PBE_PKCS5v20() [2/2]

Botan::PBE_PKCS5v20::PBE_PKCS5v20 | ( | BlockCipher * | cipher,
|  | HashFunction * | hash
| ) |  |

Parameters

  cipher | the block cipher to use
  hash | the hash function to use

Definition at line 211 of file pbes2.cpp.

References known_cipher(), and Botan::Algorithm::name().

212 :
213 direction(ENCRYPTION),
214 block_cipher(cipher),
215 hash_function(digest),
216 iterations(0),
217 key_length(0)
218 {
219 if(!known_cipher(block_cipher->name()))
220 throw Invalid_Argument("PBE-PKCS5 v2.0: Invalid cipher " + cipher->name());
221 if(hash_function->name() != "SHA-160")
222 throw Invalid_Argument("PBE-PKCS5 v2.0: Invalid digest " + digest->name());
223 }
Botan::ENCRYPTION
Definition: sym_algo.h:87
Botan::Invalid_Argument
std::invalid_argument Invalid_Argument
Definition: exceptn.h:20
Botan::Algorithm::name
virtual std::string name() const =0
Botan::PBE_PKCS5v20::known_cipher
static bool known_cipher(const std::string &cipher)
Definition: pbes2.cpp:193

## ◆ ~PBE_PKCS5v20()

Botan::PBE_PKCS5v20::~PBE_PKCS5v20 | ( |  | ) |

Definition at line 235 of file pbes2.cpp.

236 {
237 delete hash_function;
238 delete block_cipher;
239 }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::PBE_PKCS5v20::end_msg | ( |  | ) |
| virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 55 of file pbes2.cpp.

References Botan::Pipe::end_msg(), and Botan::Pipe::reset().

56 {
57 pipe.end_msg();
58 flush_pipe(false);
59 pipe.reset();
60 }
Botan::Pipe::reset
void reset()
Definition: pipe.cpp:76
Botan::Pipe::end_msg
void end_msg()
Definition: pipe.cpp:166

## ◆ known_cipher()

bool Botan::PBE_PKCS5v20::known_cipher | ( | const std::string & | cipher | ) |
| static

Parameters

  cipher | names a block cipher

Returns
  true iff PKCS #5 knows how to use this cipher

Definition at line 193 of file pbes2.cpp.

Referenced by PBE_PKCS5v20().

194 {
195 if(algo == "AES-128" || algo == "AES-192" || algo == "AES-256")
196 return true;
197 if(algo == "DES" || algo == "TripleDES")
198 return true;
199 return false;
200 }

## ◆ name()

std::string Botan::PBE_PKCS5v20::name | ( |  | ) | const
| virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 202 of file pbes2.cpp.

References Botan::Algorithm::name().

203 {
204 return "PBE-PKCS5v20(" + block_cipher->name() + "," +
205 hash_function->name() + ")";
206 }
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protected inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::MemoryRegion< T >::size(), and Botan::Filter::write().

Referenced by Botan::PK_Encryptor_Filter::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:158
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ start_msg()

void Botan::PBE_PKCS5v20::start_msg | ( |  | ) |
| virtual

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented from Botan::Filter.

Definition at line 36 of file pbes2.cpp.

References Botan::Pipe::append(), Botan::BlockCipher::clone(), Botan::Pipe::default_msg(), Botan::ENCRYPTION, Botan::Pipe::message_count(), Botan::Pipe::set_default_msg(), and Botan::Pipe::start_msg().

37 {
38 if(direction == ENCRYPTION)
39 pipe.append(new CBC_Encryption(block_cipher->clone(),
40 new PKCS7_Padding,
41 key, iv));
42 else
43 pipe.append(new CBC_Decryption(block_cipher->clone(),
44 new PKCS7_Padding,
45 key, iv));
46
47 pipe.start_msg();
48 if(pipe.message_count() > 1)
49 pipe.set_default_msg(pipe.default_msg() + 1);
50 }
Botan::Pipe::start_msg
void start_msg()
Definition: pipe.cpp:152
Botan::Pipe::append
void append(Filter *filt)
Definition: pipe.cpp:215
Botan::Pipe::default_msg
size_t default_msg() const
Definition: pipe.h:209
Botan::ENCRYPTION
Definition: sym_algo.h:87
Botan::BlockCipher::clone
virtual BlockCipher * clone() const =0
Botan::Pipe::message_count
message_id message_count() const
Definition: pipe.cpp:282
Botan::Pipe::set_default_msg
void set_default_msg(message_id msg)
Definition: pipe.cpp:106

## ◆ write()

void Botan::PBE_PKCS5v20::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 27 of file pbes2.cpp.

References Botan::Pipe::write().

28 {
29 pipe.write(input, length);
30 flush_pipe(true);
31 }
Botan::Pipe::write
void write(const byte in[], size_t length)
Definition: pipe_rw.cpp:34

The documentation for this class was generated from the following files:

- src/pbe/pbes2/pbes2.h
- src/pbe/pbes2/pbes2.cpp